# 查找编译器和Python
find_program(PYTHON_EXECUTABLE python)
find_program(GLSLANG_VALIDATOR glslangValidator)
find_program(SLANG_COMPILER slangc)

set(SHADER_PATH_FILE ${CMAKE_CURRENT_SOURCE_DIR}/scripts/shader_paths.txt)
# 删除文件
file(REMOVE ${SHADER_PATH_FILE})

function(shader_compile_target INPUT_DIR)
    # 将路径写到scripts/shader_paths.txt中
    file(WRITE ${SHADER_PATH_FILE} ${INPUT_DIR})
endfunction()

# 添加自定义命令, 用于编译着色器, 调用scripts/compile_shaders.py
add_custom_target(aorii_compile_shaders
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/scripts/compile_shaders.py --output-dir ${SHADER_OUTPUT_DIR}
    COMMENT "Compiling shaders"
    VERBATIM
)
