﻿#pragma once
#include <optional>

namespace aorii_private {
    template <typename optional_type, bool has_intrusive_unset_optional_state>
    struct optional_storage;
}

struct intrusive_unset_optional_state {
    template<typename>
    friend class std::optional;

    template<typename, bool>
    friend struct aorii_private::optional_storage;
private:
    explicit intrusive_unset_optional_state() = default;
};
