﻿#pragma once
#include "window/renderer_window.h"

#define AORII_VERSION_MAJOR 0
#define AORII_VERSION_MINOR 1
#define AORII_VERSION_PATCH 0

namespace aorii {
    struct init_info {
        window_desc main_window_desc{};
    };
    int run(const init_info& in_init_info);

    const std::chrono::duration<double>& get_delta_time();
    std::chrono::duration<double> get_total_time();
}
