﻿#pragma once
#include "font_type.h"
#include <unordered_map>

class font_manager {
public:
	void set_font_family(
		const font_family& name,
		const font_path& path,
		const font_style style = font_style::regular
	) {
		auto& entry  = family_paths[name];
		entry[style] = path;
	}
private:
	using path_entry = std::unordered_map<font_style, font_path>;

	std::unordered_map<font_family, path_entry> family_paths{};
};
